//! # DBus interface proxy for: `org.freedesktop.machine1.Machine`
//!
//! This code was generated by `zbus-xmlgen` `2.0.1` from DBus introspection data.
//! Source: `org.freedesktop.machine1-machine.xml`.
//!
//! You may prefer to adapt it, instead of using it verbatim.
//!
//! More information can be found in the
//! [Writing a client proxy](https://dbus.pages.freedesktop.org/zbus/client.html)
//! section of the zbus documentation.
//!
//! This DBus object implements
//! [standard DBus interfaces](https://dbus.freedesktop.org/doc/dbus-specification.html),
//! (`org.freedesktop.DBus.*`) for which the following zbus proxies can be used:
//!
//! * [`zbus::fdo::PeerProxy`]
//! * [`zbus::fdo::IntrospectableProxy`]
//! * [`zbus::fdo::PropertiesProxy`]
//!
//! …consequently `zbus-xmlgen` did not generate code for the above interfaces.

use zbus::dbus_proxy;

#[dbus_proxy(
    interface = "org.freedesktop.machine1.Machine",
    default_service = "org.freedesktop.machine1"
)]
trait Machine {
    /// BindMount method
    fn bind_mount(
        &self,
        source: &str,
        destination: &str,
        read_only: bool,
        mkdir: bool,
    ) -> zbus::Result<()>;

    /// CopyFrom method
    fn copy_from(&self, source: &str, destination: &str) -> zbus::Result<()>;

    /// CopyTo method
    fn copy_to(&self, source: &str, destination: &str) -> zbus::Result<()>;

    /// GetAddresses method
    fn get_addresses(&self) -> zbus::Result<Vec<(i32, Vec<u8>)>>;

    /// GetOSRelease method
    fn get_osrelease(&self) -> zbus::Result<std::collections::HashMap<String, String>>;

    /// GetUIDShift method
    fn get_uidshift(&self) -> zbus::Result<u32>;

    /// Kill method
    fn kill(&self, who: &str, signal: i32) -> zbus::Result<()>;

    /// OpenLogin method
    fn open_login(&self) -> zbus::Result<(zbus::zvariant::OwnedFd, String)>;

    /// OpenPTY method
    fn open_pty(&self) -> zbus::Result<(zbus::zvariant::OwnedFd, String)>;

    /// OpenRootDirectory method
    fn open_root_directory(&self) -> zbus::Result<zbus::zvariant::OwnedFd>;

    /// OpenShell method
    fn open_shell(
        &self,
        user: &str,
        path: &str,
        args: &[&str],
        environment: &[&str],
    ) -> zbus::Result<(zbus::zvariant::OwnedFd, String)>;

    /// Terminate method
    fn terminate(&self) -> zbus::Result<()>;

    /// Class property
    #[dbus_proxy(property)]
    fn class(&self) -> zbus::Result<String>;

    /// Id property
    #[dbus_proxy(property)]
    fn id(&self) -> zbus::Result<Vec<u8>>;

    /// Leader property
    #[dbus_proxy(property)]
    fn leader(&self) -> zbus::Result<u32>;

    /// Name property
    #[dbus_proxy(property)]
    fn name(&self) -> zbus::Result<String>;

    /// NetworkInterfaces property
    #[dbus_proxy(property)]
    fn network_interfaces(&self) -> zbus::Result<Vec<i32>>;

    /// RootDirectory property
    #[dbus_proxy(property)]
    fn root_directory(&self) -> zbus::Result<String>;

    /// Service property
    #[dbus_proxy(property)]
    fn service(&self) -> zbus::Result<String>;

    /// State property
    #[dbus_proxy(property)]
    fn state(&self) -> zbus::Result<String>;

    /// Timestamp property
    #[dbus_proxy(property)]
    fn timestamp(&self) -> zbus::Result<u64>;

    /// TimestampMonotonic property
    #[dbus_proxy(property)]
    fn timestamp_monotonic(&self) -> zbus::Result<u64>;

    /// Unit property
    #[dbus_proxy(property)]
    fn unit(&self) -> zbus::Result<String>;
}
